/*
        prototype.c 1.0 for X11R6 & GNU C Compiler

        Copyright (C) 1999 Syllabub
        Maroontress Fast Software.
*/

#include <stdio.h>

#include "packet.h"
#include "prototype.h"

void
PrintPrototype(FILE *fp, PacketList *pl)
{
    Type *mem;
    Packet *ptr;

    fprintf(fp,
	    "/*\n"
	    "\tThis file is automatically generated by ximpc.\n"
	    "\tDon't edit this file.\n"
	    "*/\n"
	    "\n"
	    "#include <X11/Xproto.h>\n"
	    "\n"
	    "typedef struct {\n"
	    "\tCARD8 *s;\n"
	    "\tCARD8 *c;\n"
	    "} Chunk;\n"
	    "\n"
	    "typedef struct {\n"
	    "\tCARD8 major_opcode;\n"
	    "\tCARD8 minor_opcode;\n"
	    "\tCARD16 length;\n"
	    "\tCARD8 data[0];\n"
	    "} Packet;\n"
	    "\n"
	    "void Free_Packet(Packet *);\n"
	    "\n"
	    "typedef CARD8 * STRING8;\n"
	    "typedef xEvent XEVENT;\n"
	    "\n"
	    "typedef struct LIST {\n"
	    "\tstruct LIST *next;\n"
	    "\tvoid *data;\n"
	    "} LIST;\n"
	    "\n"
	    "typedef struct STR {\n"
	    "\tCARD8  len;\n"
	    "\tSTRING8 val;\n"
	    "} STR;\n"
	    "\n"
	    "STR * Recv_STR(CARD8 *);\n"
	    "void Free_STR(STR *p);\n"
	    "\n"
	    "typedef struct STRING {\n"
	    "\tCARD16  len;\n"
	    "\tSTRING8 val;\n"
	    "\t/* PAD (4 bytes alignment) */\n"
	    "} STRING;\n"
	    "\n"
	    "STRING * Recv_STRING(CARD8 *);\n"
	    "void Free_STRING(STRING *p);\n");

    for (ptr = pl->top; ptr != NULL; ptr = ptr->next) {
	if (ptr->head == NULL)
	    continue;
	fprintf(fp, "\n" "typedef struct %s {\n", ptr->type);
	for (mem = ptr->head; mem != NULL; mem = mem->next) {
	    if (strcmp(mem->name, "PAD") == 0) {
		fprintf(fp, "\t" "/* PAD (4 bytes alignment) */\n");
	    }
	    else if (mem->is_list == Array) {
		fprintf(fp,
			"\t" "struct {\n"
			"\t\t" "CARD16\tnum;\n"
			"\t\t" "%s\t**val;\n"
			"\t" "} %s;\n",
			mem->name, mem->member);
	    }
	    else if (mem->is_list == Listof) {
		fprintf(fp, "\t" "LIST\t*%s;\n", mem->member);
	    }
	    else if (mem->is_list == Multi) {
		fprintf(fp,
			"\t" "struct {\n"
			"\t\t" "CARD16\tnum;\n"
			"\t\t" "%s\t*val;\n"
			"\t" "} %s;\n",
			mem->name, mem->member);
	    }
	    else {
		fprintf(fp, "\t" "%s\t%s;\n", mem->name, mem->member);
	    }
	}
	fprintf(fp, "} %s;\n\n", ptr->type);
	if (ptr->to_do == Read || ptr->to_do == Both) {
	    fprintf(fp, "%s * Recv_%s(CARD8 *);\n", ptr->type, ptr->type);
	}
	fprintf(fp, "void Free_%s(%s *);\n", ptr->type, ptr->type);
	if (ptr->to_do == Write || ptr->to_do == Both) {
	    fprintf(fp, "void Send_%s(%s *, int, Packet **, int *);\n",
		    ptr->type, ptr->type);
	}
	fprintf(fp, "void Read_%s(%s *, Chunk *);\n", ptr->type, ptr->type);
	fprintf(fp, "void Write_%s(%s *, Chunk *);\n", ptr->type, ptr->type);
	fprintf(fp, "int Sizeof_%s(%s *, int);\n", ptr->type, ptr->type);
    }
}
